Send asset
curl --request POST \
--url https://api.hyperliquid.xyz/exchange \
--header 'Content-Type: application/json' \
--data '
{
"action": {
"type": "sendAsset",
"hyperliquidChain": "Mainnet",
"signatureChainId": "0xa4b1",
"destination": "0x1234567890abcdef1234567890abcdef12345678",
"sourceDex": "HL",
"destinationDex": "HL",
"token": "PURR:0x1",
"amount": "100.0",
"fromSubAccount": "",
"nonce": 1705234567890
},
"nonce": 1705234567890,
"signature": {
"r": "0x0000000000000000000000000000000000000000000000000000000000000000",
"s": "0x0000000000000000000000000000000000000000000000000000000000000000",
"v": 27
},
"vaultAddress": null
}
'import requests
url = "https://api.hyperliquid.xyz/exchange"
payload = {
"action": {
"type": "sendAsset",
"hyperliquidChain": "Mainnet",
"signatureChainId": "0xa4b1",
"destination": "0x1234567890abcdef1234567890abcdef12345678",
"sourceDex": "HL",
"destinationDex": "HL",
"token": "PURR:0x1",
"amount": "100.0",
"fromSubAccount": "",
"nonce": 1705234567890
},
"nonce": 1705234567890,
"signature": {
"r": "0x0000000000000000000000000000000000000000000000000000000000000000",
"s": "0x0000000000000000000000000000000000000000000000000000000000000000",
"v": 27
},
"vaultAddress": None
}
headers = {"Content-Type": "application/json"}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'Content-Type': 'application/json'},
body: JSON.stringify({
action: {
type: 'sendAsset',
hyperliquidChain: 'Mainnet',
signatureChainId: '0xa4b1',
destination: '0x1234567890abcdef1234567890abcdef12345678',
sourceDex: 'HL',
destinationDex: 'HL',
token: 'PURR:0x1',
amount: '100.0',
fromSubAccount: '',
nonce: 1705234567890
},
nonce: 1705234567890,
signature: {
r: '0x0000000000000000000000000000000000000000000000000000000000000000',
s: '0x0000000000000000000000000000000000000000000000000000000000000000',
v: 27
},
vaultAddress: null
})
};
fetch('https://api.hyperliquid.xyz/exchange', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"status": "<string>",
"response": {}
}Hyperliquid node API
sendAsset | Hyperliquid exchange
Sends a spot asset to another address on Hyperliquid L1. sendAsset JSON-RPC method available on the Hyperliquid exchange blockchain via Chainstack.
POST
/
exchange
Send asset
You can only use this endpoint on the official Hyperliquid public API. It is not available through Chainstack, as the open-source node implementation does not support it yet. See Hyperliquid methods for the full availability breakdown.
This endpoint requires signature authentication. See our comprehensive Authentication via Signatures guide for implementation details.
Get your own node endpoint todayStart for free and get your app to production levels immediately. No credit card required.You can sign up with your GitHub, X, Google, or Microsoft account.
Parameters
Required parameters
action(object, required) — The action object containing:type(string) — Must be"sendAsset"hyperliquidChain(string) — Chain identifierdestination(string) — Recipient addresstoken(string) — Token to sendamount(string) — Amount to sendtime(integer) — Current timestamp in milliseconds
nonce(number, required) — Current timestamp in milliseconds (must be recent)signature(object, required) — EIP-712 signature of the action
Optional parameters
vaultAddress(string, optional) — Address when trading on behalf of a vault or subaccount
Returns
Returns an object with the action status:status—"ok"if request processedresponse— Contains action result data
Example request
curl -X POST https://api.hyperliquid.xyz/exchange \
-H "Content-Type: application/json" \
-d '{
"action": {"type": "sendAsset"},
"nonce": 1234567890123,
"signature": {...}
}'
import eth_account
from hyperliquid.exchange import Exchange
from hyperliquid.utils import constants
# Load your wallet from a private key (keep it secret — never hardcode in production)
wallet = eth_account.Account.from_key("0x...")
# Public Hyperliquid API (this method is available on the official API only)
exchange = Exchange(wallet, constants.MAINNET_API_URL)
# Send a spot asset to another address.
# sourceDex/destinationDex: "" for the default perp dex, "spot" for spot.
result = exchange.send_asset(
destination="0x0000000000000000000000000000000000000001",
source_dex="spot",
destination_dex="spot",
token="USDC:0xeb62eee3685fc4c43992febcd9e75443",
amount=1,
)
print(result)
import { ExchangeClient, HttpTransport } from "@nktkas/hyperliquid";
import { privateKeyToAccount } from "viem/accounts";
// Load your wallet from a private key (keep it secret — never hardcode in production)
const wallet = privateKeyToAccount("0x...");
// Public Hyperliquid API (this method is available on the official API only)
const transport = new HttpTransport();
const exchange = new ExchangeClient({ transport, wallet });
// Send a spot asset to another address.
// sourceDex/destinationDex: "" for the default perp dex, "spot" for spot.
const result = await exchange.sendAsset({
destination: "0x0000000000000000000000000000000000000001",
sourceDex: "spot",
destinationDex: "spot",
token: "USDC:0xeb62eee3685fc4c43992febcd9e75443",
amount: "1",
});
console.log(result);
Use case
- Send asset — Sends a spot asset to another address on Hyperliquid L1.
Always ensure your system clock is synchronized. Nonce must be within a reasonable time window of the current server time or the request will be rejected.
Body
application/json
Last modified on June 24, 2026
Was this page helpful?
⌘I